'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stream = require('stream');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * An in-memory transport adapter.
 *
 * @type {MemoryTransport}
 */

var MemoryTransport =

/**
 * Constructor.
 */

function MemoryTransport() {
  _classCallCheck(this, MemoryTransport);

  var client = new _stream.Duplex({ objectMode: true });
  var server = new _stream.Duplex({ objectMode: true });

  client._read = function () {};
  client._write = function (data, encoding, next) {
    setImmediate(function () {
      server.push(data);
      next();
    });
  };

  server._read = function () {};
  server._write = function (data, encoding, next) {
    setImmediate(function () {
      client.push(data);
      next();
    });
  };

  this.client = client;
  this.server = server;
};

/**
 * Export.
 *
 * @type {Object}
 */

exports.default = MemoryTransport;